(function($){

	var timeout = false;

	$(document).ready( function () {

		$('.custom-timeline .slider').slick({
		  dots: false,
		  arrows: true,
		  infinite: false,
		  speed: 300,
		  slidesToShow: 4,
		  slidesToScroll: 1,
		  adaptiveHeight: true,
		  responsive: [
			{
			  breakpoint: 1300,
			  settings: {
				slidesToShow: 3,
				slidesToScroll: 1,
				arrows: true,
			  }
			},
			{
			  breakpoint: 900,
			  settings: {
				slidesToShow: 2,
				slidesToScroll: 1,
				arrows: true,
			  }
			},
			{
			  breakpoint: 700,
			  settings: {
				slidesToShow: 1,
				slidesToScroll: 1,
				arrows: true,
			  }
			}
		  ]
		});

		$('.custom-timeline .date-slider').slick({
		  dots: false,
		  arrows: true,
		  infinite: false,
		  speed: 300,
		  slidesToShow: 7,
		  slidesToScroll: 7,
		  responsive: [
			{
			  breakpoint: 1024,
			  settings: {
				slidesToShow: 4,
				slidesToScroll: 4,
				infinite: true,
				arrows: true,
			  }
			},
			{
			  breakpoint: 600,
			  settings: {
				slidesToShow: 4,
				slidesToScroll: 4,
				arrows: true,
			  }
			},
		  ]
		});

		setTimeout( size_text, 500);
		setTimeout( set_active, 500);


		// setInterval(background_scrolling, 1000);

		set_click_events();

		// $('.custom-timeline .slider').on('afterChange', function(event, slick, currentSlide){
		// 	clearTimeout(timeout);

		// 	timeout = setTimeout(function () {
		// 		$('.custom-timeline .date-slider').slick('slickGoTo', currentSlide - 1 );
		// 		$('.active-date').removeClass('active-date');
		// 		$('.custom-timeline .date-slider [data-slick-index="'+currentSlide+'"]').addClass('active-date');
		// 	}, 1000);
		// });

	});


	// function background_scrolling(){
		// console.log('test');
		// $('.lightboxes div').each(function(){
			// if($(this).hasClass('active')){
				// $('body').addClass('noscroll');
			// } else {
				// $('body').removeClass('noscroll');
			// }
		// })
	// }

	$(window).resize( size_text );

	$(document).on( 'click', '.lightboxes a.close', function (e) {

		$(this).parents('.active').find('.lb-slider').each( function () {

			$(this).slick('unslick');
		});

		$(this).parents( '.active' ).removeClass( 'active' );
		$('body' ).removeClass( 'noscroll' );
		e.preventDefault();
	});

	function set_click_events(){
		$(document).on( 'click', '.custom-timeline .slider a', function (e) {

		var index = $(this).parents( '.inner' ).data( 'id' );

		// console.log( 'Opening lightbox with index: ' + index );

		$('.custom-timeline .lightboxes > div[data-id="'+ index +'"]').addClass( 'active' );

		$('.custom-timeline .lightboxes > div[data-id="'+ index +'"] .lb-slider').each( function () {

			$(this).slick({
			  slidesToShow: 1,
			  slidesToScroll: 1,
			  autoplay: true,
			  autoplaySpeed: 2000,
			  dots: true,
			  arrows: false,
			});
		});

		$('body' ).addClass( 'noscroll' );

		e.preventDefault();
		});
	}

	$(document).on( 'mouseenter', '.slider .slick-track', function () {

		$(this).addClass( 'user-active' );
	});

	$(document).on( 'mouseleave', '.slider .slick-track', function () {

		$(this).removeClass( 'user-active' );
	});

	$(document).on( 'click', '.custom-timeline .slider button.slick-arrow', set_active );

	$(document).on( 'click', '.date-slider p, .date-slider i', set_focus );

	function set_focus () {

		$( '.slick-slide.focused-date' ).removeClass( 'focused-date' );
		$( '.slick-slide.active-date' ).removeClass( 'active-date' );
		$(this).parents( '.slick-slide' ).addClass( 'focused-date' );

		var date = parseInt($(this).parents( '.slick-slide' ).find('p').text());

		$('.custom-timeline .slider .slick-slide').each( function () {

			if ( parseInt($(this).find('h2').text()) == date ) {

				$(this).addClass( 'focused-date' );
			}
		});

		check_focus();
	}

	function check_focus () {

		if( $('.custom-timeline .slider .focused-date').hasClass( 'slick-active' ) ){

			$('.focused-date').removeClass( 'culprit' );
			// console.log( 'Focused item is in view' );

		} else {

			$('.focused-date').addClass( 'culprit' );

			hunt_culprit();
			focus_timeout = setTimeout(check_focus, 1);
		}
	}

	function hunt_culprit () {

		// find if 'culprit' is closer to the left active slide, or right active slide
		var culpritIndex = $('.slider .culprit').data( 'slick-index' );
		var leftIndex = $('.slider .slick-active').first().data( 'slick-index' );

		// console.log( 'culprits index: ' + culpritIndex );
		// console.log( 'left active index: ' + leftIndex );

		if ( leftIndex > culpritIndex ) {

			$('.custom-timeline .slider .slick-prev').click();

		} else {

			$('.custom-timeline .slider .slick-next').click();
		}
	}

	function set_active () {

		if ( $('.slider .focused-date').length && $('.slider .focused-date').hasClass( 'slick-active' ) ) {

			// console.log( 'an item is focused and in view, cancelling active processing' );
			return;
		}

		if ( $('.culprit').length ) {

			// console.log( 'searching for culprit' );
			return;
		}

		if ( $('.slider .active-date.slick-active').length ) {

			// console.log( 'an item is active and in view, cancelling active processing' );
			return;
		}

		$('.focused-date').removeClass( 'focused-date' );

		var target = '';

		if ( $(this).hasClass( 'slick-next' ) ) {
			target = '.slick-next';
		} if ( $(this).hasClass( 'slick-prev' ) ) {
			target = '.slick-prev';
		}

		// console.log( 'target: ' + target );

		$('.custom-timeline .slider .active-date').removeClass( 'active-date' );
		$('.custom-timeline .date-slider .active-date').removeClass( 'active-date' );
		$('.custom-timeline .slider .slick-active').first().addClass( 'active-date' );

		var date = parseInt( $('.slider .active-date h2').text() );

		$('.date-slider .slick-slide').each( function () {

			if ( parseInt($(this).find('p').text()) == date ) {

				$(this).addClass( 'active-date' );
			}
		});

		if ( !$('.date-slider .active-date').hasClass( 'slick-active' ) ) {

			$( '.date-slider ' + target ).click();
		}
	}

	function size_text () {

		var height = 0;
		$('.custom-timeline .slider .slick-slide p:nth-of-type(1)').css( 'min-height', '0px' );

		$('.custom-timeline .slider .slick-slide p:nth-of-type(1)').each( function () {

			if ( $(this).outerHeight() > height ) {

				height = $(this).outerHeight();
			}
		});

		$('.custom-timeline .slider .slick-slide p:nth-of-type(1)').css( 'min-height', height + 'px' );

		$('.slider button.slick-arrow').css( 'min-height', $('.slider .slick-slide').first().outerHeight() + 'px' );
	}

})(jQuery)
